// HtmlWnd.cpp : implementation file
//

#include "stdafx.h"
#include "XDRMDIVW.h"
#include "HtmlWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "atlbase.h"

/////////////////////////////////////////////////////////////////////////////
// CHtmlWnd

CHtmlWnd::CHtmlWnd()
{
}

CHtmlWnd::~CHtmlWnd()
{
}


BEGIN_MESSAGE_MAP(CHtmlWnd, CWnd)
	//{{AFX_MSG_MAP(CHtmlWnd)
   ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CHtmlWnd::Create( LPCTSTR          lpszWindowName, 
                       DWORD            dwStyle,
                       const RECT     & rect,
                       CWnd           * pParentWnd, 
                       UINT             nID ,
                       CCreateContext * pContext /*=NULL*/ )
{
   return CreateControl( CLSID_WebBrowser, 
                         lpszWindowName, 
                         dwStyle, 
                         rect, 
                         pParentWnd, 
                         nID ); 
}

bool CHtmlWnd::Navigate( LPCTSTR pczURL )
{
   if ( pczURL != NULL )   
      {
      CComVariant varDummy ;
      CComVariant varURL( pczURL ) ;
      CComQIPtr<IWebBrowser2> spWB = GetControlUnknown() ; 
      // ----
      ASSERT( spWB.p != NULL ) ;

      return SUCCEEDED( spWB->Navigate2( &varURL , &varDummy , &varDummy , &varDummy , &varDummy ) ) ;
      }
   else
      { ASSERT(FALSE) ; }

   return false ;
}

bool CHtmlWnd::LoadFromResource(UINT nRes)
{
	HINSTANCE hInstance = AfxGetResourceHandle();
	ASSERT(hInstance != NULL);

	CString strResourceURL;
	bool bRetVal = true;
	LPTSTR lpszModule = new TCHAR[_MAX_PATH];

	if (GetModuleFileName(hInstance, lpszModule, _MAX_PATH))
	{
		strResourceURL.Format(_T("res://%s/%d"), lpszModule, nRes);
		Navigate(strResourceURL);
	}
	else
		bRetVal = false;

	delete [] lpszModule;
	return bRetVal;
}

/////////////////////////////////////////////////////////////////////////////
// CHtmlWnd message handlers
//----------------------------------------------------------------------------

BOOL CHtmlWnd::OnEraseBkgnd(CDC* pDC)
{
   return CWnd::OnEraseBkgnd(pDC) ;
}

//----------------------------------------------------------------------------

void CHtmlWnd::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	
}

//----------------------------------------------------------------------------
