// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "XDRMDIVW.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// class CMyMDIClient
//----------------------------------------------------------------------------

CMyMDIClient::CMyMDIClient() :
   m_bInit(false)
{
}

CMyMDIClient::~CMyMDIClient()
{
}


BEGIN_MESSAGE_MAP(CMyMDIClient, CWnd)
	//{{AFX_MSG_MAP(CMyMDIClient)
   ON_WM_CREATE()
   ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//----------------------------------------------------------------------------

int CMyMDIClient::OnCreate(LPCREATESTRUCT lpCreateStruct )
{
   return CWnd::OnCreate( lpCreateStruct ) ;
}

/////////////////////////////////////////////////////////////////////////////
// CHtmlWnd message handlers
//----------------------------------------------------------------------------

void CMyMDIClient::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here

   if ( ::IsWindow( m_hWnd ) && ::IsWindow( m_HtmlWnd.m_hWnd ) )
      {
      m_HtmlWnd.SetWindowPos( NULL , 0 , 0 , cx , cy , SWP_NOMOVE|SWP_NOZORDER ) ;
      }
}

//----------------------------------------------------------------------------

BOOL CMyMDIClient::OnEraseBkgnd(CDC* pDC)
{
   if ( m_bInit == false )
      {
      CRect rc ;
      // ----
      GetClientRect( &rc ) ;

      BOOL bRet = m_HtmlWnd.Create( NULL , 
                                    WS_VISIBLE|WS_CHILD , 
                                    rc , 
                                    this , 
                                    42 , 
                                    NULL ) ;

      m_HtmlWnd.LoadFromResource(IDR_HTML1) ;
      
      m_bInit = true ;
      }
   
   return CWnd::OnEraseBkgnd(pDC) ;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	if (!m_wndDlgBar.Create(this, IDD_DLGBAR  /*IDR_MAINFRAME*/ , 
		CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0("Failed to create dialogbar\n");
		return -1;		// fail to create
	}

	if (!m_wndReBar.Create(this) ||
		!m_wndReBar.AddBar(&m_wndToolBar) ||
		!m_wndReBar.AddBar(&m_wndDlgBar))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY);

#if 0 // TO DO ????????
   // Subclass the MDI client window   
   CRect rc ;
   // ----
   GetClientRect( &rc ) ;
   VERIFY( m_wndClient.Create( NULL , WS_VISIBLE|WS_CHILD , rc , this , 42 , NULL ) );
#endif

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	if ( CMDIFrameWnd::OnCreateClient(lpcs, pContext) != FALSE )
      {
#if 0

      CRect rc ;
      // ----
      GetClientRect( &rc ) ;

      BOOL bRet = m_wndClient.Create( NULL , 
                                 WS_VISIBLE|WS_CHILD , 
                                 rc , 
                                 CWnd::FromHandle( m_hWndMDIClient ) , // this , 
                                 42 , 
                                 NULL ) ;

      m_wndClient.LoadFromResource(IDR_HTML1) ;

      return bRet ;

#else      
      return m_MDIClient.SubclassWindow(m_hWndMDIClient) ;
#endif
      }
    else
      {
      return FALSE ;
      }
}

/////////////////////////////////////////////////////////////////////////////
// 
